UIPackage
Menu

Framework

Change language

Boilerplate repo

Lazy Image

lazy-imageui

Lazy-loaded image with aspect-ratio reservation, skeleton placeholder, fade-in transition, and error fallback. Composes loading="lazy" with IntersectionObserver for off-viewport hold and pairs with the skeleton primitive for the placeholder state.

Also available for React ->

Installation

$npx shadcn-vue@latest add https://uipkge.dev/r/vue/lazy-image.json
Named registry:npx shadcn-vue@latest add @uipkge/lazy-imageInstalls to:app/components/ui/lazy-image/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
srcstringrequired
srcsetstringoptional
sizesstringoptional
altstringrequired
aspectRatiostring | numberoptional
widthstring | numberoptional
heightstring | numberoptional
placeholder
'skeleton''none'
'skeleton'optional
coverbooleantrueoptional
eagerbooleanfalseoptional
fallbackstringoptional
transitionbooleantrueoptional
classHTMLAttributes['class']optional
imgClassHTMLAttributes['class']optional

Includes

Files installed (2)

  • app/components/ui/lazy-image/Img.vue4.1 kB
    <script setup lang="ts">
    import { computed, onBeforeUnmount, onMounted, ref, watch } from 'vue'
    import type { HTMLAttributes } from 'vue'
    import { cn } from '@/lib/utils'
    import { Skeleton } from '@/components/ui/skeleton'
    
    type Placeholder = 'skeleton' | 'none'
    
    const props = withDefaults(
      defineProps<{
        src: string
        srcset?: string
        sizes?: string
        alt: string
        aspectRatio?: string | number
        width?: string | number
        height?: string | number
        placeholder?: Placeholder
        cover?: boolean
        eager?: boolean
        fallback?: string
        transition?: boolean
        class?: HTMLAttributes['class']
        imgClass?: HTMLAttributes['class']
      }>(),
      {
        placeholder: 'skeleton',
        cover: true,
        eager: false,
        transition: true,
      },
    )
    
    const emits = defineEmits<{
      (e: 'load', event: Event): void
      (e: 'error', event: Event): void
    }>()
    
    const root = ref<HTMLElement | null>(null)
    const state = ref<'idle' | 'loading' | 'loaded' | 'error'>('idle')
    const visible = ref(props.eager)
    
    const aspectStyle = computed((): Record<string, string> => {
      const r = props.aspectRatio
      if (r === undefined) return {}
      if (typeof r === 'number') return { aspectRatio: String(r) }
      return { aspectRatio: r }
    })
    
    const sizeStyle = computed((): Record<string, string> => {
      const out: Record<string, string> = {}
      if (props.width !== undefined) out.width = typeof props.width === 'number' ? `${props.width}px` : props.width
      if (props.height !== undefined) out.height = typeof props.height === 'number' ? `${props.height}px` : props.height
      return out
    })
    
    const containerStyle = computed(() => ({ ...aspectStyle.value, ...sizeStyle.value }))
    
    let observer: IntersectionObserver | null = null
    
    function teardownObserver() {
      observer?.disconnect()
      observer = null
    }
    
    function setupObserver() {
      teardownObserver()
      if (props.eager || typeof IntersectionObserver === 'undefined' || !root.value) {
        visible.value = true
        return
      }
      observer = new IntersectionObserver(
        (entries) => {
          for (const entry of entries) {
            if (entry.isIntersecting) {
              visible.value = true
              teardownObserver()
              return
            }
          }
        },
        { rootMargin: '200px' },
      )
      observer.observe(root.value)
    }
    
    onMounted(() => {
      setupObserver()
    })
    
    onBeforeUnmount(() => {
      teardownObserver()
    })
    
    watch(
      () => props.src,
      () => {
        state.value = 'idle'
        if (props.eager) {
          visible.value = true
          return
        }
        visible.value = false
        setupObserver()
      },
    )
    
    watch(visible, (v) => {
      if (v && state.value === 'idle') state.value = 'loading'
    })
    
    function onLoad(e: Event) {
      state.value = 'loaded'
      emits('load', e)
    }
    
    function onError(e: Event) {
      state.value = 'error'
      emits('error', e)
    }
    </script>
    
    <template>
      <div
        ref="root"
        data-uipkge
        data-slot="lazy-image"
        :class="cn('bg-muted relative overflow-hidden', props.class)"
        :style="containerStyle"
      >
        <Skeleton
          v-if="placeholder === 'skeleton' && state !== 'loaded' && state !== 'error'"
          class="absolute inset-0 size-full rounded-none"
        />
    
        <img
          v-if="visible && state !== 'error'"
          :src="src"
          :srcset="srcset"
          :sizes="sizes"
          :alt="alt"
          :loading="eager ? 'eager' : 'lazy'"
          :decoding="eager ? 'sync' : 'async'"
          :class="
            cn(
              'block size-full',
              cover ? 'object-cover' : 'object-contain',
              transition && 'transition-opacity duration-300',
              state === 'loaded' ? 'opacity-100' : 'opacity-0',
              imgClass,
            )
          "
          @load="onLoad"
          @error="onError"
        />
    
        <template v-if="state === 'error'">
          <slot name="fallback">
            <img
              v-if="fallback"
              :src="fallback"
              :alt="alt"
              :class="cn('block size-full', cover ? 'object-cover' : 'object-contain', imgClass)"
            />
            <div
              v-else
              role="img"
              class="text-muted-foreground absolute inset-0 flex items-center justify-center text-xs"
              aria-label="Image failed to load"
            >
              <span aria-hidden="true">Image unavailable</span>
            </div>
          </slot>
        </template>
      </div>
    </template>
    
  • app/components/ui/lazy-image/index.ts0 kB

Raw manifest:https://uipkge.dev/r/vue/lazy-image.json

UIPackage
Menu

Framework

Change language

Boilerplate repo

Lazy Image

lazy-imageui

Lazy-loaded image with aspect-ratio reservation, skeleton placeholder, fade-in transition, and error fallback. Composes loading="lazy" with IntersectionObserver for off-viewport hold and pairs with the skeleton primitive for the placeholder state.

Also available for Vue ->

Installation

$npx shadcn@latest add https://uipkge.dev/r/react/lazy-image.json
Named registry:npx shadcn@latest add @uipkge-react/lazy-imageInstalls to:components/ui/lazy-image/

Examples

Loading interactive previews…

Props

NameType / ValuesDefaultRequired
srcstringrequired
srcSetstringoptional
sizesstringoptional
altstringrequired
aspectRatiostring | numberoptional
widthstring | numberoptional
heightstring | numberoptional
placeholderPlaceholderoptional
coverbooleanoptional
eagerbooleanoptional
fallbackstringoptional
transitionbooleanoptional
classNamestringoptional
imgClassNamestringoptional
fallbackContent

`#fallback` named slot).

React.ReactNodeoptional
onLoad(e: React.SyntheticEvent<HTMLImageElement, Event>) => voidoptional
onError(e: React.SyntheticEvent<HTMLImageElement, Event>) => voidoptional

Includes

Files installed (2)

  • components/ui/lazy-image/Img.tsx4.5 kB
    'use client'
    
    import * as React from 'react'
    import { cn } from '@/lib/utils'
    import { Skeleton } from '@/components/ui/skeleton'
    
    type Placeholder = 'skeleton' | 'none'
    
    export interface ImgProps {
      src: string
      srcSet?: string
      sizes?: string
      alt: string
      aspectRatio?: string | number
      width?: string | number
      height?: string | number
      placeholder?: Placeholder
      cover?: boolean
      eager?: boolean
      fallback?: string
      transition?: boolean
      className?: string
      imgClassName?: string
      /** Override the default error fallback (React equivalent of the Vue
       *  `#fallback` named slot). */
      fallbackContent?: React.ReactNode
      onLoad?: (e: React.SyntheticEvent<HTMLImageElement, Event>) => void
      onError?: (e: React.SyntheticEvent<HTMLImageElement, Event>) => void
    }
    
    function Img({
      src,
      srcSet,
      sizes,
      alt,
      aspectRatio,
      width,
      height,
      placeholder = 'skeleton',
      cover = true,
      eager = false,
      fallback,
      transition = true,
      className,
      imgClassName,
      fallbackContent,
      onLoad,
      onError,
    }: ImgProps) {
      const rootRef = React.useRef<HTMLDivElement | null>(null)
      const [state, setState] = React.useState<'idle' | 'loading' | 'loaded' | 'error'>('idle')
      const [visible, setVisible] = React.useState(eager)
    
      const aspectStyle: React.CSSProperties = React.useMemo(() => {
        if (aspectRatio === undefined) return {}
        if (typeof aspectRatio === 'number') return { aspectRatio: String(aspectRatio) }
        return { aspectRatio }
      }, [aspectRatio])
    
      const sizeStyle: React.CSSProperties = React.useMemo(() => {
        const out: React.CSSProperties = {}
        if (width !== undefined) out.width = typeof width === 'number' ? `${width}px` : width
        if (height !== undefined) out.height = typeof height === 'number' ? `${height}px` : height
        return out
      }, [width, height])
    
      const containerStyle = { ...aspectStyle, ...sizeStyle }
    
      // Reset + (re)observe when the source changes.
      React.useEffect(() => {
        setState('idle')
        if (eager) {
          setVisible(true)
          return
        }
        setVisible(false)
    
        if (typeof IntersectionObserver === 'undefined' || !rootRef.current) {
          setVisible(true)
          return
        }
    
        const observer = new IntersectionObserver(
          (entries) => {
            for (const entry of entries) {
              if (entry.isIntersecting) {
                setVisible(true)
                observer.disconnect()
                return
              }
            }
          },
          { rootMargin: '200px' },
        )
        observer.observe(rootRef.current)
        return () => observer.disconnect()
      }, [src, eager])
    
      // Transition idle -> loading once the element becomes visible.
      React.useEffect(() => {
        if (visible) setState((s) => (s === 'idle' ? 'loading' : s))
      }, [visible])
    
      function handleLoad(e: React.SyntheticEvent<HTMLImageElement, Event>) {
        setState('loaded')
        onLoad?.(e)
      }
    
      function handleError(e: React.SyntheticEvent<HTMLImageElement, Event>) {
        setState('error')
        onError?.(e)
      }
    
      return (
        <div
          ref={rootRef}
          data-uipkge=""
          data-slot="lazy-image"
          className={cn('bg-muted relative overflow-hidden', className)}
          style={containerStyle}
        >
          {placeholder === 'skeleton' && state !== 'loaded' && state !== 'error' && (
            <Skeleton className="absolute inset-0 size-full rounded-none" />
          )}
    
          {visible && state !== 'error' && (
            <img
              src={src}
              srcSet={srcSet}
              sizes={sizes}
              alt={alt}
              loading={eager ? 'eager' : 'lazy'}
              decoding={eager ? 'sync' : 'async'}
              className={cn(
                'block size-full',
                cover ? 'object-cover' : 'object-contain',
                transition && 'transition-opacity duration-300',
                state === 'loaded' ? 'opacity-100' : 'opacity-0',
                imgClassName,
              )}
              onLoad={handleLoad}
              onError={handleError}
            />
          )}
    
          {state === 'error' &&
            (fallbackContent !== undefined ? (
              fallbackContent
            ) : fallback ? (
              <img
                src={fallback}
                alt={alt}
                className={cn('block size-full', cover ? 'object-cover' : 'object-contain', imgClassName)}
              />
            ) : (
              <div
                role="img"
                className="text-muted-foreground absolute inset-0 flex items-center justify-center text-xs"
                aria-label="Image failed to load"
              >
                <span aria-hidden="true">Image unavailable</span>
              </div>
            ))}
        </div>
      )
    }
    
    export { Img }
    
  • components/ui/lazy-image/index.ts0 kB

Raw manifest:https://uipkge.dev/r/react/lazy-image.json